#include<iostream>
#include<vector>
using namespace std;
int N,Q,sum[100000],parent[100000];
bool a[100000];
void f(int m){
    if(parent[m]!=0){
        sum[parent[m]]++;
        f(parent[m]);
    }
}
int main(){
    int m,n;
    cin>>N;
    for(int i=1;i<N;i++){
        cin>>m>>n;
        parent[n]=m;
        a[m]=true;
    }
    for(int i=1;i<=N;i++){
        f(i);
    }
    cin>>Q;
    for(int i=0;i<Q;i++){
        cin>>m;
        cout<<sum[m]<<endl;
    }
return 0;
}
